
gameState = 1
menuSelect = 1
showPrev = 1
power = 1
answer = "2"
prevAnswer = "2"
input = ""
wrong = 0	

function on.paint(gc)
	if gameState == 1 then
		gc:setFont("sansserif", "r", 44)
		gc:drawString("Powers of 2", 70, 30, "middle")
		gc:setFont("sansserif", "r", 16)
		gc:drawString("By Philip Sun", 110, 65, "middle")

		gc:drawString("Show Previous Power:", 20, 110, "middle")
		
		if showPrev == 1 then
			gc:drawString("Yes", 195, 110, "middle")
		else
			gc:drawString("No", 198, 110, "middle")
		end

		gc:setFont("sansserif", "r", 26)
		gc:drawString("Begin", 115, 160, "middle")

		if menuSelect == 1 then
			gc:fillPolygon({193,105, 193,115, 186,110})
			gc:fillPolygon({226,105, 227,115, 233,110})
		end

		if menuSelect == 2 then
			gc:drawPolyLine({111,140, 205, 140, 205, 180, 111, 180, 111,140})
			gc:drawPolyLine({110,139, 206, 139, 206, 181, 110, 181, 110,139})
		end
	end

	if gameState == 2 then
		gc:setFont("sansserif", "r", 44)
		gc:drawString("Powers of 2", 70, 30, "middle")
		gc:setFont("sansserif", "r", 16)
		gc:drawString("By Philip Sun", 110, 65, "middle")

		gc:setFont("sansserif", "r", 9)
		gc:drawString("Press Escape to go Back to the Menu", 60, 185, "middle")

		gc:setFont("sansserif", "r", 20)
		gc:drawString("2", 20, 140, "middle")

		gc:setFont("sansserif", "r", 14)
		gc:drawString(power, 37, 130, "middle")

		gc:setFont("sansserif", "r", 20)
		gc:drawString(":", 52, 140, "middle")

		gc:setFont("sansserif", "r", 11)
		gc:drawString(input, 63, 146, "middle")

		if wrong == 1 then
			gc:drawString("Incorrect! Please try again.", 77, 170, "middle")
		end

		if showPrev == 1 and power ~= 1 then
			gc:drawString("Previous:", 20, 100, "middle")
			gc:drawString(prevAnswer, 90, 100, "middle")
		end
	end
end

function on.arrowUp()
	if gameState == 1 and menuSelect == 2 then
		menuSelect = 1
		platform.window:invalidate()
	end
end

function on.arrowDown()
	if gameState == 1 and menuSelect == 1 then
		menuSelect = 2
		platform.window:invalidate()
	end
end

function on.arrowLeft()
	if gameState == 1 and menuSelect == 1 then
		if showPrev == 1 then
			showPrev = 0
		else
			showPrev = 1
		end
		platform.window:invalidate()
	end
end

function on.arrowRight()
	if gameState == 1 and menuSelect == 1 then
		if showPrev == 1 then
			showPrev = 0
		else
			showPrev = 1
		end
		platform.window:invalidate()
	end
end

function on.enterKey()
	if gameState == 1 and menuSelect == 2 then
		gameState = 2
		platform.window:invalidate()

	else
		input = string.gsub(input, " ", "")
		answer = string.gsub(answer, " ", "")
		if input == answer then
			wrong = 0
			power = power + 1
			input = ""
			prevAnswer = answer

			local nextAnswer
			for i = #answer, 1, -1 do
				if i == #answer then
					nextAnswer = (2 * string.sub(answer, #answer, #answer)) % 10
				else
					nextAnswer = (((2 * string.sub(answer, i, i)) % 10) + ((2 * string.sub(answer, i + 1, i + 1) - (2 * string.sub(answer, i + 1, i + 1)) % 10) / 10))..nextAnswer
				end
			end

			if string.sub(answer, 1, 1) == "5" or string.sub(answer, 1, 1) == "6"  or 
			   string.sub(answer, 1, 1) == "7" or string.sub(answer, 1, 1) == "8" or string.sub(answer, 1, 1) == "9" then
				nextAnswer = "1"..nextAnswer
			end
			answer = nextAnswer
			platform.window:invalidate()
		else
			wrong = 1
			platform.window:invalidate()
		end
	end
end

function on.escapeKey()
	if gameState == 2 then
		gameState = 1
		menuSelect = 1
		power = 1
		answer = 2
		input = ""
		wrong = 0
		platform.window:invalidate()
	end
end

function on.backspaceKey()
	if input ~= "" then
		input = string.sub(input, 1, #input - 1)
		platform.window:invalidate()
	end
end

function on.charIn(ch)
	if gameState == 2 then
		if ch == "0" or ch == "1" or ch == "2" or ch == "3" or ch == "4" or ch == "5" or ch == "6" or ch == "7" or ch == "8" or ch == "9" then
			if #input ~= 30 then
				input = input..ch
				platform.window:invalidate()
			end
		end
	end
end